#include <iostream>
#include <signal.h>
#include <vector>
using namespace std;

int main()
{
    std::vector<pid_t> cats;
    pid_t ppid=getpid();
    short input=-1;
    while (input!=0){
        cout<<"--Cat Hotel menu--"<<endl<<"1. Add cat"<<endl;
        if (!cats.empty())cout<<"2. Manage cats"<<endl;
        cout<<"0. Kill all cats and exit"<<endl;
        std::cin>>input;
        if(input==1){
            pid_t pid=fork();
            if (pid==0){
                cout<<"Meow! (Cat "<<getpid()<<')'<<endl;
                while(true){
                    kill(getpid(),SIGSTOP);
                    for (char a=0;a<3;a++) {cout<<"Chew. "<<flush;sleep(1);}
                    cout<<"Done."<<flush;
                }
            } else {cats.push_back(pid);usleep(1);};
        }else if(input==2){
        if(cats.empty())cout << "No cats to manage!"<<endl;else {
            cout<<"Current cats:"<<endl;
            for (unsigned short i=0;i<cats.size();++i)cout<<i+1<<". Cat PID: "<<cats[i]<<endl;
            cout<<"Choose a cat to manage (input invalid number to cancel): ";
            cin>>input;
            if(input==0)input=-1;else
            if(input>0 && input<=cats.size()){
                pid_t cat_pid = cats[input - 1];
                cout<<"1. Feed"<<endl<<"0. Kill"<<endl;
                unsigned short input2;cin >> input2;
                if (input2 == 1) {
                    kill(cat_pid, SIGCONT);
                    sleep(4);cout<<endl;
                } else if (input2 == 0) {
                    kill(cat_pid, SIGKILL);
                    cout << "Cat " << cat_pid << " killed!" << endl;
                    cats.erase(cats.begin()+input);
                    input=-1;
                } else cout << "Invalid action!" << endl;
            }
        }
    }
}
    for (pid_t cat : cats)kill(cat, SIGKILL);
    return 0;
}
